library m_hook;

uses Windows;

{$R SHOOT.RES}

const WM_DESTROY = 2;
      WM_LBUTTONDOWN = $0201;
      WM_NCLBUTTONDOWN = $00A1;
      SND_MEMORY = 4;
      SND_ASYNC = 1;

var HookID:HHOOK;
    pt:TPoint;
    Rec:trect;
    r1,r2:hrgn;
    shoot:pointer;
    h:hmodule;

function PlaySound(pszSound: PChar; hmod: HMODULE; fdwSound: DWORD):BOOL; stdcall; external 'winmm.dll' name 'PlaySound';

function MouseHook(nCode, WParam, LParam:integer):Longint; stdcall;
var
 msg:PMouseHookStruct;
 Wind:HWND;
begin
 if nCode<0 then begin
  result:=CallNextHookEx(HookID,nCode,wParam,lParam);
  exit;
 end;
 msg:=PMouseHookStruct(lParam);
 if (wParam=WM_LBUTTONDOWN) or (wparam=WM_NCLBUTTONDOWN) then begin
  pt:=msg^.pt; // 
  Wind:=msg^.hwnd; //  

  h:=GetModuleHandle('m_hook.dll');  // 
  shoot:=LockResource(LoadResource(h,FindResource(h,'SHOOT',RT_RCDATA)));
  playsound(shoot,h,SND_MEMORY or snd_async);

  getwindowrect(Wind,rec);  //  
  r1:=CreateEllipticRgn(pt.X-rec.Left-8,pt.y-rec.Top-8,pt.x-rec.Left+8,pt.y-rec.Top+8);
  rec.Top:=0;
  rec.Left:=0;
  r2:=CreateRectRgnIndirect(rec);
  CombineRgn(r2,r2,r1,RGN_XOR);
  r1:=CreateRectRgnIndirect(rec);
  GetWindowRgn(wind,r1);
  CombineRgn(r2,r2,r1,RGN_AND);
  SetWindowRgn(wind, r2, true);
 end;
 result:=CallNextHookEx(HookID, nCode, wParam, lParam);
end;

procedure SetHook; stdcall;
begin
 HookID:=SetWindowsHookEx(wh_mouse, @MouseHook, hInstance, 0);
end;

procedure DelHook; stdcall;
begin
 UnhookWindowsHookEx(HookID);
end;

exports
  SetHook,
  DelHook;

begin
end.
